{% extends "front/base_logged.html" %}
{% load i18n %}

{% block content %}

    {% include "wizard/header.html" %}

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Informação Adicional" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
              <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                  <span class="glyphicon glyphicon-info-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
          {% include "wizard/help_text/step_auxfiles.html" %}
      </div>
      <div class="panel-body">
        {% blocktrans trimmed %}
        Neste passo o utilizador deverá selecionar alguns parâmetros adicionais do modelo, podendo especificar valores ou carregar um ficheiro quando existir variabilidade espacial dos mesmos.
        {% endblocktrans %}
      </div>
    </div>

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    <form class="form" method="post" enctype="multipart/form-data">{% csrf_token %}
        <div data-step="1" data-intro="{% trans 'Preencha o Formulário' %}">
            {{ forms.management_form }}
            {% include "front/form.html" %}
        </div>

        <div class="row btnmenu">
            <div class="col-xs-6">
                <button id="btn_prev" type="button" class="btn btn-default" data-step="4" data-intro="{% trans 'Pode sempre revisitar passos anteriores' %}">
                    <span class="glyphicon glyphicon-arrow-left"></span> {% trans "Anterior" %}
                </button>
                <button id="btn_restart" class="btn btn-default" data-step="3" data-intro="{% trans 'ou limpe e recomeçe o passo' %}" data-toggle="tooltip" data-placement="top" title="{% trans 'Reset do passo e apaga passos posteriores' %}">{% trans "Recomeçar passo" %}</button>
            </div>
            <div class="col-xs-6 text-right">
                {% if request.session.last_step < step %}
                <button id="btn_submit" type="submit" name="next" class="btn btn-primary" data-step="2" data-intro="{% trans 'Prima o botão' %}">
                    {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% else %}
                <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="{% trans 'Aplicar alterações efetuadas ao passo' %}" data-step="2" data-intro="{% trans 'Se efetuar alterações ao passo prima este botão para as guardar' %}">
                    {% trans "Guardar alterações" %}
                </button>
                <button id="btn_next" class="btn btn-default" data-step="5" data-intro="{% trans 'Ou passos posteriores' %}">
                    {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% endif %}
            </div>
        </div>
    </form>

    <script type="text/javascript">
        // Toggle Visibility of Forms
        function toggleForms(e) {
            // Condition visible fields
            var choice = $('[name="' + e.name + '"]:checked').val();
            if (choice == 'C') {
                $(e).closest(".forms").find('input[type="number"]').closest(".fieldWrapper").show();
                $(e).closest(".forms").find('input[type="number"]').attr('required', '');
                $(e).closest(".forms").find('input[type="file"]').closest(".fieldWrapper").hide();
                $(e).closest(".forms").find('input[type="text"]').closest(".fieldWrapper").hide();
                $(e).closest(".forms").find('input[type="file"]').removeAttr('required');
            } else {
                $(e).closest(".forms").find('input[type="number"]').closest(".fieldWrapper").hide();
                $(e).closest(".forms").find('input[type="number"]').removeAttr('required');
                $(e).closest(".forms").find('input[type="file"]').closest(".fieldWrapper").show();
                $(e).closest(".forms").find('input[type="text"]').closest(".fieldWrapper").show();
                $(e).closest(".forms").find('input[type="file"]').attr('required', '');
            }
            // Remove focus
            $(e).blur();
        }

        // Submit Step event
        $('#btn_submit').click(function(e){
            var flagok = true;
            var msg = '{% trans "Para continuar terá de preencher os campos em falta." %}';

            try {
                var fileupload = false;

                // Validate fields
                $("input[type='radio']:checked").each(function(){
                    var frm = this.name.replace('choice', '');
                    var opt = this.value;
                    if (opt == 'C') {
                        // Validate if constant is filled, its required
                        var constant = $('input[name="' + frm + 'constant"]');
                        if (constant.val() == '') {
                            flagok = false;
                            constant.focus();
                        } else {
                            // Validate if constant field is valid
                            if (!constant[0].validity.valid) {
                                flagok = false;
                                constant.focus();
                                msg = '{% trans "Para continuar terá de corrigir os campos inválidos." %}';
                            }
                        }
                    } else if (opt == 'U') {
                        if ($('input[name="' + frm + 'file"]').val() == '') flagok = false;
                        fileupload = true;
                    }
                });

                if (!flagok) {
                    $('#msg_str').html(msg);
                    $('#divModal_msg').modal('show');
                    return false;
                }

                $('#divModal_processing').modal('show');

                var btnname = e.currentTarget.name;
                if (btnname == 'edit') {
                    e.preventDefault();

                    var cType = 'application/x-www-form-urlencoded; charset=UTF-8', pData = true;
                    var formdata = $('.form').serialize();
                    if (fileupload) {
                        $.ajaxSetup({beforeSend: function(xhr, settings){
                            xhr.setRequestHeader('X-CSRFToken', '{{ csrf_token }}');
                        }});

                        // Ajax POST has different settings if files are uploaded
                        cType = false;
                        pData = false;
                        formdata = new FormData($('.form').get(0));
                    }

                    // Send simple form data via client-side
                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}'.replace(/0/, step),
                        data: formdata,
                        contentType: cType,
                        processData: pData,
                        success: function(data) {
                            $('#divModal_processing').modal('hide');

                            if (data["msg"]) {
                                $('#msg_str').html(data["msg"]);
                                $('#divModal_msg').modal('show');
                            }
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $('#divModal_processing').modal('hide');

                            $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                            $('#divModal_msg').modal('show');
                        }
                    });
                }
            } catch(err) {
                e.preventDefault();
                console.log(err);
                $('#divModal_processing').modal('hide');

                $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                $('#divModal_msg').modal('show');
            }
        });

        // On Document Ready
        $(function(){
            // Label forms and condition visible fields
            $('.forms').each(function(){
                // Add title to form
                var label = '';
                var labels = $(this).find('[name*="label"]');
                if (labels.length > 0) label = labels[0].value;
                $(this).before("<p class='grouptitle'>" + label + "</p>");

                // Check choice selection
                var choice = $(this).find('[type="radio"]:checked');
                if (choice.length > 0) {
                    if (choice[0].value == 'C') {
                        $(this).find('input[type="number"]').closest(".fieldWrapper").show();
                        $(this).find('input[type="file"]').closest(".fieldWrapper").hide();
                    } else {
                        $(this).find('input[type="number"]').closest(".fieldWrapper").hide();
                        $(this).find('input[type="file"]').closest(".fieldWrapper").show();
                    }
                }
            });
        });
    </script>
{% endblock content %}